#ifndef DB_ACCESS_H
#define DB_ACCESS_H


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <fcntl.h>

typedef struct
{
	uint16_t year;
	uint8_t  month;
	uint8_t  day;
} db_date_t;

typedef struct 
{
	db_date_t date;
	uint32_t millis;
}db_time_t;

typedef struct 
{
	db_date_t date;
	uint32_t micros;
} db_data_t;

typedef struct
{
	off_t start;
	off_t len;
} db_interval_t;

typedef struct 
{
	db_date_t date;
	off_t index;
} db_metadata_t;

typedef struct 
{
	off_t ndays;
	db_metadata_t* days;
	
	off_t nmonthes;
	db_metadata_t* monthes;
	
	off_t nyears;
	db_metadata_t* years;
	
	off_t data_count;
} db_index_t;


typedef struct 
{
	off_t   start;
	off_t   len;
	db_data_t* data;
} db_data_interval_t;





void db_index_release(db_index_t* in);
int  db_index_load(db_index_t* out);

void 								db_data_interval_free(db_data_interval_t* dbdi);


#endif
